<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Vue List Person</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    <script src="https://unpkg.com/vue@3"></script>
</head>

<body>

    <div class="container mt-5" id="app">
        <button class="btn btn-primary" @click="fetchPersons()">Fetch Persons</button>
        <div class="row">
            <div class="col-4" v-for="person in persons" :key="person.id">
                <div class="card  mb-4">
                    <div class="card-body">
                        <h2 class="card-title">{{person.name}}</h2>
                        <p class="card-text">{{person.firstname}}, age : {{person.age}}</p>
                    </div>
                </div>
            </div>
        </div>

        <form @submit.prevent="addPerson()">
            <label for="name">Name : </label>
            <input type="text" class="form-control" id="name" v-model="newPerson.name">
            <label for="firstname">Firstname : </label>
            <input type="text" class="form-control" id="firstname" v-model="newPerson.firstname">
            <label for="age">age : </label>
            <input type="number" class="form-control" id="age" v-model="newPerson.age">
            <button class="btn btn-primary">Add</button>

        </form>
    </div>


    <script>
        Vue.createApp({
            data() {
                return {
                    persons: [],
                    newPerson: {
                        name: '',
                        firstname: '',
                        age: 0
                    }
                }
            },
            methods: {
                async fetchPersons() {
                    const reponse = await fetch('/api/person');
                    this.persons = await reponse.json();
                },
                async addPerson() {
                    const reponse = await fetch('/api/person', {
                        body: JSON.stringify(this.newPerson),
                        method: 'POST',
                        headers: {
                            'Content-Type': 'application/json'
                        }
                    });
                    this.persons.push(await reponse.json());
                }
            }
        }).mount('#app')
    </script>

</body>

</html>
